* ------------------------------------------------------------
*    Tonkyun Panic Library
*     tonpani
*                                             (C)1995 nenetto
* ------------------------------------------------------------
*
RCSID:		.dc.b	'@(#)$Id: _zoom.s,v 1.3 1995-03-20 16:58:21+0900 nenetto Exp $',0
		.even

		.xdef	_zoomA
		.xdef	_zoomB


* ------------------------------------------------------------
*	256*256̈̊g/k
*	256*256->1*1, 256*256->256*256, 1*1->256*256
*
*	input	d0.b : center of source gram address
*		d1.l : distination gram address
*		d7.l : zoom rate (0..255) (ŏ{..ő{)
*	output	d7.l : ----
*
_zoomB:
		move.l	d7,-(sp)
		andi.w	#$ff,d7
		cmp.w	#128,d7
		bcc	1f
		 bsr	_zoomB_
		bra	2f

	1:	 bsr	_zoomA
	2:	move.l	(sp)+,d7
		rts


* ------------------------------------------------------------
*	256*256->1*1, 256*256->256*256
*
*	input	d0.b : center of source gram address
*		d1.l : distination gram address
*		d7.l : zoom rate (0..128..255) (ŏ{....)
*	output	d7.l : ----
*
_zoomB_:
		movem.l	d0-d7/a0-a6,-(sp)
		
		andi.w	#$3ff,d7
		addq	#1,d7
		 bsr	_zoomB_init
		
		movea.l	d1,a1
		movea.l	d0,a2
		lea	_y_table,a3
		move.w	#256-1,d7
		1:	movea.l	a2,a0
			move.l	(a3)+,d0
			cmp.l	#-1,d0
			beq	2f
			
			adda.l	d0,a0
			cmpa.l	#$c00000+$400,a0
			bcs	2f
			cmpa.l	#$d00000,a0
			bcc	2f
			 jsr	_draw
			lea	$400-256*2(a1),a1
		dbra	d7,1b
		bra	3f
		
		2:	 bsr	_clear
			lea	$400(a1),a1
		dbra	d7,1b
		
	3:	movem.l	(sp)+,d0-d7/a0-a6
		rts


* ------------------------------------------------------------
*	_zoomB p̕`惋[`쐬
*
_zoomB_init:
		movem.l	d0-d7/a0-a6,-(sp)
		
		lea	_draw,a1
		lea	_y_table,a3
		move.w	#-2,d2
		move.l	#-$400,d3
		move.w	#%0011_001_011_101_000,d4	* move.w d16(a0),(a1)+
		move.w	#%01000010_01_011_001,d5	* clr.w (a1)+
		
		moveq	#127,d6
		@@:	move.l	d6,d0
			lsl.w	#7,d0
			divu	d7,d0
			add.w	d0,d0
			not.w	d0
			and.l	d2,d0
			cmp.w	d7,d6
			bcs	2f
			move.w	d5,(a1)+		* 
			move.l	#-1,(a3)+		* 
			bra	3f
		2:
			move.w	d4,(a1)+		* 
			move.w	d0,(a1)+		* 
			ext.l	d0
			lsl.l	#8,d0
			add.l	d0,d0
			move.l	d0,(a3)+		* 
		3:
		dbra	d6,@b
		
		moveq	#0,d6
		@@:	move.l	d6,d0
			lsl.w	#7,d0
			divu	d7,d0
			add.w	d0,d0
			cmp.w	d7,d6
			bcs	2f
			move.w	d5,(a1)+		* 
			move.l	#-1,(a3)+		* 
			bra	3f
		2:
			move.w	d4,(a1)+		* 
			move.w	d0,(a1)+		* 
			ext.l	d0
			lsl.l	#8,d0
			add.l	d0,d0
			move.l	d0,(a3)+		* 
		3:
		addq	#1,d6
		cmp.w	#128,d6
		bne	@b
		
		move.w	#$4e75,(a1)			* rts
		
		movem.l	(sp)+,d0-d7/a0-a6
		rts
* ------------------------------------------------------------



* ------------------------------------------------------------
*	512*512̈̊g/k
*	512*512->256*256, 256*256->256*256, 1*1->256*256
*
*	input	d0.b : center of source gram address
*		d1.l : distination gram address
*		d7.l : zoom rate (0..128..255) (1/2{....ő{)
*	output	d7.l : ----
*
_zoomA:
		movem.l	d0-d7/a0-a6,-(sp)
		
		andi.w	#$ff,d7
		not.b	d7
		 bsr	_zoomA_init
		
		movea.l	d1,a1
		movea.l	d0,a2
		lea	_y_table,a3
		move.w	#256-1,d7
		1:	movea.l	a2,a0
			adda.l	(a3)+,a0
			cmpa.l	#$c00000+$400,a0
			bcs	2f
			cmpa.l	#$d00000,a0
			bcc	2f
			 jsr	_draw
			lea	$400-256*2(a1),a1
		dbra	d7,1b
		bra	3f
		
		2:	 bsr	_clear
			lea	$400(a1),a1
		dbra	d7,1b
	3:	
		movem.l	(sp)+,d0-d7/a0-a6
		rts

* ------------------------------------------------------------
*	_zoomA p̕`惋[`쐬
*
_zoomA_init:
		movem.l	d0-d7/a0-a6,-(sp)
		
		lea	_draw,a1
		lea	256*4(a1),a2
		lea	_y_table,a3
		lea	256*4(a3),a4
		move.w	#$4e75,(a2)			* rts
		move.w	#-2,d2
		move.l	#-$400,d3
		move.w	#%0011_001_011_101_000,d4	* move.w d16(a0),(a1)+
		
		moveq	#128-1,d6
		@@:	move.w	d6,d0
			mulu	d7,d0
			move.l	d0,d1
			lsr.w	#6,d0		* /128 *2
			and.w	d2,d0
			move.w	d0,-(a2)		* 
			move.w	d4,-(a2)		* 
			
			lsl.l	#3,d1		* y *128 *8
			and.l	d3,d1
			move.l	d1,-(a4)		* 
			
			not.w	d0
			subq	#1,d0
			move.w	d4,(a1)+		* 
			move.w	d0,(a1)+		* 
			
			not.l	d1
			and.l	d3,d1
			move.l	d1,(a3)+
		dbra	d6,@b

		movem.l	(sp)+,d0-d7/a0-a6
		rts
* ------------------------------------------------------------


* ------------------------------------------------------------
_clear:
		moveq	#0,d0
		moveq	#0,d1
		moveq	#0,d2
		moveq	#0,d3
		moveq	#0,d4
		moveq	#0,d5
		moveq	#0,d6
		suba.l	a6,a6
		movem.l	d0-d6/a6,(a1)
		movem.l	d0-d6/a6,$20(a1)
		movem.l	d0-d6/a6,$40(a1)
		movem.l	d0-d6/a6,$60(a1)
		movem.l	d0-d6/a6,$80(a1)
		movem.l	d0-d6/a6,$a0(a1)
		movem.l	d0-d6/a6,$c0(a1)
		movem.l	d0-d6/a6,$e0(a1)
		movem.l	d0-d6/a6,$100(a1)
		movem.l	d0-d6/a6,$120(a1)
		movem.l	d0-d6/a6,$140(a1)
		movem.l	d0-d6/a6,$160(a1)
		movem.l	d0-d6/a6,$180(a1)
		movem.l	d0-d6/a6,$1a0(a1)
		movem.l	d0-d6/a6,$1c0(a1)
		movem.l	d0-d6/a6,$1e0(a1)
		rts
* ------------------------------------------------------------

		.data
_draw:		.dcb.w	256*2+1,0
_y_table:	.dcb.l	256,0
		.text
* ------------------------------------------------------------


		.end
