* ------------------------------------------------------------
*    Tonkyun Panic Library
*     tonpani
*                                             (C)1995 nenetto
* ------------------------------------------------------------
*
RCSID:		.dc.b	'@(#)$Id: _sprite.s,v 1.2 1995-03-20 16:58:01+0900 nenetto Exp $',0
		.even

		.xdef	_locate
		.xdef	_put_sprite
		.xdef	_erase_sprite
		.xdef	_clear_sprite


DI		macro
		ori.w	#$0700,sr
		endm

EI		macro
		andi.w	#$f8ff,sr
		endm

* ------------------------------------------------------------
		.data
T_sprite::	.dcb.l	128+1,0
			* data address(.l)
		.text

* ------------------------------------------------------------
*	XvCg\Cv[Ww
*
*	input	d0.l : object
*		d1.l : data location
*		d7.l : ----
*	output	d7.l : ----
*
_locate:	movem.l	d0-d1,-(sp)
		cmp.l	#3,d0
		bcc	_sp
		neg.w	d1
		swap	d1
		neg.w	d1
		swap	d1
		cmp.l	#0,d0
		beq	_g0
		cmp.l	#1,d0
		beq	_g1
		move.l	d1,$e80014
		bra	_e
	_g0:	move.l	d1,$e80018
		move.l	d1,$e8001c
		bra	_e
	_g1:	move.l	d1,$e80020
		move.l	d1,$e80024
		bra	_e
	_sp:	 bsr	_put_sprite
	_e:	movem.l	(sp)+,d0-d1
		rts


* ------------------------------------------------------------
*	XvCg\
*
*	input	d0.l : data address
*		d1.l : data location
*		d7.l : ----
*	output	d7.l : ----
*
_put_sprite:
		DI
		movem.l	d0-d7/a0-a6,-(sp)
		
		btst	#1,$e80028		* XvCg\\
		bne	4f
		btst	#3,$e80028
		bne	4f
		
		movea.l	d0,a0			* data address
		move.w	(a0),d2			* XvCggp
		subq	#1,d2
		
		lea	T_sprite,a1
		moveq	#0,d7
		moveq	#128-1,d6
		1:	cmp.w	d2,d6
			bcs	4f		* \I[o[
			tst.l	(a1)
			beq	2f		* YȂ
			cmp.l	(a1),d0
			beq	3f		* ̂
			addq	#4,a1
			addq	#1,d7
		dbra	d6,1b
	bra	3f
	
		2:	move.l	d0,(a1)+
		dbra	d2,2b
		clr.l	(a1)
		
	3:	move.l	d1,d0
		 bsr	_sp_on
	4:
		movem.l	(sp)+,d0-d7/a0-a6
		EI
		rts


* ------------------------------------------------------------
*	XvCg\
*
*	input	d0.l : data address
*		d1.l : ----
*		d7.l : ----
*	output	d7.l : ----
*
_erase_sprite:
		DI
		movem.l	d0-d7/a0-a6,-(sp)
		
		btst	#1,$e80028		* XvCg\\
		bne	5f
		btst	#3,$e80028
		bne	5f
		
		lea	T_sprite,a1
		lea	$eb0000,a3
		moveq	#128-1,d6
		1:	tst.l	(a1)
			beq	5f		* YȂ
			cmp.l	(a1),d0
			beq	2f		* ݂
			addq	#4,a1
			addq	#8,a3
		dbra	d6,1b
	bra	5f
	
	2:	movea.l	d0,a0			* data address
		move.w	(a0),d1			* XvCggp
		movea.l	a1,a2
		add.w	d1,d1
		add.w	d1,d1
		adda.w	d1,a2
		movea.l	a3,a4
		add.w	d1,d1
		adda.w	d1,a4
		
		3:	move.l	(a4),(a3)+
			clr.l	(a4)+
			move.l	(a4),(a3)+
			clr.l	(a4)+
			move.l	(a2),(a1)+
			clr.l	(a2)+
			tst.l	(a2)
		bne	3b
		4:	clr.l	(a3)+
			clr.l	(a3)+
			clr.l	(a1)+
			tst.l	(a1)
		bne	4b

	5:
		movem.l	(sp)+,d0-d7/a0-a6
		EI
		rts




*	a0.l: data address
*	d0.l: data location
*	d7.l: data number (0..127)
_sp_on:
	movem.l	d0-d7/a0-a6,-(sp)
	
	addq	#2,a0
	move.w	d7,d1
	add.w	d1,d1
	add.w	d1,d1
	add.w	d1,d1
	lea	$eb0000,a1
	adda.w	d1,a1
	move.l	(a0)+,d1			* sprite register +4

	moveq	#$f,d2
	sub.w	(a0)+,d2			* X̃XvCg -1
	move.w	(a0)+,d3			* ỸXvCg -1
	move.l	(a0)+,d4			* X̃gbvW+16, ỸgbvW+16
	add.w	d0,d4
	and.l	#$ffff0000,d0
	add.l	d0,d4
	move.l	d4,d5
	moveq	#1,d7
	swap.w	d7
	moveq	#$10,d0
	swap.w	d0
	moveq	#$10,d6
	add.w	d2,d2
	add.w	d2,d2
	add.w	d2,d2
	lea	T_sp_put(pc,d2.w),a0
	jmp	(a0)

T_sp_put:
	move.l	d4,(a1)+
	move.l	d1,(a1)+
	add.l	d7,d1
	add.l	d0,d4
	move.l	d4,(a1)+
	move.l	d1,(a1)+
	add.l	d7,d1
	add.l	d0,d4
	move.l	d4,(a1)+
	move.l	d1,(a1)+
	add.l	d7,d1
	add.l	d0,d4
	move.l	d4,(a1)+
	move.l	d1,(a1)+
	add.l	d7,d1
	add.l	d0,d4
	move.l	d4,(a1)+
	move.l	d1,(a1)+
	add.l	d7,d1
	add.l	d0,d4
	move.l	d4,(a1)+
	move.l	d1,(a1)+
	add.l	d7,d1
	add.l	d0,d4
	move.l	d4,(a1)+
	move.l	d1,(a1)+
	add.l	d7,d1
	add.l	d0,d4
	move.l	d4,(a1)+
	move.l	d1,(a1)+
	add.l	d7,d1
	add.l	d0,d4
	move.l	d4,(a1)+
	move.l	d1,(a1)+
	add.l	d7,d1
	add.l	d0,d4
	move.l	d4,(a1)+
	move.l	d1,(a1)+
	add.l	d7,d1
	add.l	d0,d4
	move.l	d4,(a1)+
	move.l	d1,(a1)+
	add.l	d7,d1
	add.l	d0,d4
	move.l	d4,(a1)+
	move.l	d1,(a1)+
	add.l	d7,d1
	add.l	d0,d4
	move.l	d4,(a1)+
	move.l	d1,(a1)+
	add.l	d7,d1
	add.l	d0,d4
	move.l	d4,(a1)+
	move.l	d1,(a1)+
	add.l	d7,d1
	add.l	d0,d4
	move.l	d4,(a1)+
	move.l	d1,(a1)+
	add.l	d7,d1
	add.l	d0,d4
	move.l	d4,(a1)+
	move.l	d1,(a1)+
	add.l	d7,d1
	add.l	d0,d4
	subq.w	#1,d3
	bcs	_sp_on_p_end
	add.w	d6,d5
	move.l	d5,d4
	jmp	(a0)

_sp_on_p_end:
	movem.l	(sp)+,d0-d7/a0-a6
	rts



* ------------------------------------------------------------
*	XvCgS
*
*	input	d0.l : ----
*		d1.l : ----
*		d7.l : ----
*	output	d7.l : ----
*
_clear_sprite:
		DI
		movem.l	d0/a0,-(sp)
		
		btst	#1,$e80028		* XvCg\\
		bne	2f
		btst	#3,$e80028
		bne	2f
		
		lea	T_sprite,a0
		lea	$eb0000,a1
		moveq	#128-1,d0
		1:	tst.l	(a0)
			beq	2f
			clr.l	(a0)+
			clr.l	(a1)+
			clr.l	(a1)+
		dbra	d0,1b
	2:	
		movem.l	(sp)+,d0/a0
		EI
		rts
* ------------------------------------------------------------


		.end
