* ------------------------------------------------------------
*    Tonkyun Panic Library
*     tonpani
*                                             (C)1995 nenetto
* ------------------------------------------------------------
*
RCSID:		.dc.b	'@(#)$Id: _trace.s,v 1.3 1995-03-20 16:58:07+0900 nenetto Exp $',0
		.even

		.include	_doscall.mac
		.xdef		_trace
		.xdef		_rec_trace
		.xdef		_save_trace


		.offset	0
x:		.ds.w	1		* xW
y:		.ds.w	1		* yW
xofst:		.ds.w	1		* xWItZbg
yofst:		.ds.w	1		* yWItZbg
data:		.ds.l	1		* trace data address
speed:		.ds.w	1		* speed
count:		.ds.w	1		* counter
repeat:		.ds.b	1		* repeat flag
		.text


* ------------------------------------------------------------
*	g[XL^
*
*  input  (a0).w : xW
*        2(a0).w : yW
*        4(a0).w : xWItZbg
*        6(a0).w : yWItZbg
*        8(a0).l : g[Xf[^AhX
*
_rec_trace:
		movem.l	d0-d6/a0-a6,-(sp)
		
		moveq	#0,d7
		move.l	$ace.w,d0			* _MS_CURGT
		move.l	d0,x(a0)
		move.w	xofst(a0),d1
		add.w	d1,x(a0)
		move.w	yofst(a0),d1
		add.w	d1,y(a0)
		
		movea.l	data(a0),a1
		move.w	(a1),d1
		cmp.w	#128*256/4,d1			* buffer over?
		bcc	@f
		
		add.w	#1,(a1)
		lsl.w	#2,d1
		move.l	d0,2(a1,d1.w)
		moveq	#-1,d7
	@@:
		movem.l	(sp)+,d0-d6/a0-a6
		rts


* ------------------------------------------------------------
*	g[XĐ
*
*  input  (a0).w : xW
*        2(a0).w : yW
*        4(a0).w : xWItZbg
*        6(a0).w : yWItZbg
*        8(a0).l : g[Xf[^AhX
*       12(a0).w : Xs[h
*       14(a0).w : JE^
*       16(a0).b : s[gtO
*
_trace:
		movem.l	d0-d6/a0-a6,-(sp)
		
		movea.l	data(a0),a1
		
		moveq	#0,d7
		move.w	count(a0),d0
		bmi	1f
		lsr.w	#3,d0
		cmp.w	(a1),d0
		bcs	2f
		tst.b	repeat(a0)
		beq	3f
		clr.w	count(a0)
		bra	2f
	
	1:	tst.b	repeat(a0)
		beq	3f
		move.w	(a1),d0
		subq	#1,d0
		lsl.w	#3,d0
		move.w	d0,count(a0)
	
	2:	moveq	#-1,d7
		
		move.w	count(a0),d0
		lsr.w	#1,d0
		andi.w	#-4,d0
		move.l	2(a1,d0.w),x(a0)
		move.w	xofst(a0),d0
		add.w	d0,x(a0)
		move.w	yofst(a0),d0
		add.w	d0,y(a0)
		
		move.w	speed(a0),d0
		add.w	d0,count(a0)
	3:
		movem.l	(sp)+,d0-d6/a0-a6
		rts


* ------------------------------------------------------------
*	g[Xf[^t@C֏o
*
_save_trace:
		movem.l	d0-d7/a0-a6,-(sp)
		
		movea.l	d0,a0
		move.w	#%10_0000,-(sp)
		pea	M_fname(pc)
		DOS	_CREATE
		addq	#6,sp
		move.w	d0,-(sp)
		
		moveq	#0,d1
		move.w	(a0),d1
		lsl.l	#2,d1
		addq	#2,d1
		move.l	d1,-(sp)
		pea	(a0)
		move.w	d0,-(sp)
		DOS	_WRITE
		lea	10(sp),sp
		
		DOS	_CLOSE
		addq	#2,sp
		
		movem.l	(sp)+,d0-d7/a0-a6
		rts
	
M_fname:	.dc.b	'trace.dat',0
		.even
* ------------------------------------------------------------


		.end
